%define name     openssl
%define ver      0.9.6b
%define rel      6

%define openssldir /var/ssl
%define __prefix /usr

Summary: Secure Sockets Layer and cryptography libraries and tools
Name: %{name}
Version: %{ver}
Release: %{rel}
Serial: 2003031101
Source0: ftp://ftp.openssl.org/pub/openssl/%{name}-%{ver}.tar.gz
Patch0:  openssl-0.9.6a-make.patch
Patch1:  openssl-0.9.6b-sec.patch
Patch2:  openssl-0.9.6c-asn.patch.3
Patch3:  openssl-0.9.6-malloc-negative.patch
Patch4:  openssl-0.9.6-vaudenay.patch
Patch5:  openssl-sec3-blinding-0.9.6b.patch
Patch6:  openssl-0.9.7a-klima-pokorny-rosa.patch

Copyright: Freely distributable
Group: System Environment/Libraries
Provides: SSL
URL: http://www.openssl.org/
BuildRoot: /var/tmp/%{name}-%{ver}-root
PreReq: /sbin/ldconfig
BuildRequires: bc
Prefix: %{__prefix}
#NoSource: 0

%description
The OpenSSL Project is a collaborative effort to develop a robust,
commercial-grade, fully featured, and Open Source toolkit implementing the
Secure Sockets Layer (SSL v2/v3) and Transport Layer Security (TLS v1)
protocols with full-strength cryptography world-wide. The project is
managed by a worldwide community of volunteers that use the Internet to
communicate, plan, and develop the OpenSSL tookit and its related
documentation. 

OpenSSL is based on the excellent SSLeay library developed from Eric A.
Young and Tim J. Hudson.  The OpenSSL toolkit is licensed under an
Apache-style licence, which basically means that you are free to get and
use it for commercial and non-commercial purposes. 

This package contains the base OpenSSL cryptography and SSL/TLS 
libraries and tools.

%package devel
Summary: Secure Sockets Layer and cryptography static libraries and headers
Group: Development/Libraries
Requires: openssl
%description devel
The OpenSSL Project is a collaborative effort to develop a robust,
commercial-grade, fully featured, and Open Source toolkit implementing the
Secure Sockets Layer (SSL v2/v3) and Transport Layer Security (TLS v1)
protocols with full-strength cryptography world-wide. The project is
managed by a worldwide community of volunteers that use the Internet to
communicate, plan, and develop the OpenSSL tookit and its related
documentation. 

OpenSSL is based on the excellent SSLeay library developed from Eric A.
Young and Tim J. Hudson.  The OpenSSL toolkit is licensed under an
Apache-style licence, which basically means that you are free to get and
use it for commercial and non-commercial purposes. 

This package contains the the OpenSSL cryptography and SSL/TLS 
static libraries and header files required when developing applications.

%changelog
* Wed Apr 2 2003 Jun YOSHIDA <jun@miraclelinux.com>
- fixed security issue.

* Tue Mar 11 2003 Jun YOSHIDA <jun@miraclelinux.com>
- fixed timing attack vulnerbility.

* Tue Sep 17 2002 Jun YOSHIDA <jun@miraclelinux.com>
- appliced asn patch.

* Fri Aug 02 2002 Jun YOSHIDA <jun@miraclelinux.com>
- applied security patch.

* Thu Jul 26 2001 NONAKA Akira<anonaka@miraclelinux.com>
- comment out 'cp -a' in %install section since it will cause error

* Tue Jul 10 2001 Toshihiro Yamagishi<toshihiro@turbolinux.co.jp>
- updated to 0.9.6b

* Thu Jun 7 2001 Go Taniguchi <go@turbolinux.co.jp>
- fixed lib soname, not require perl5

* Fri Apr 27 2001 Toshihiro Yamagishi<toshihiro@turbolinux.co.jp>
- added extra provides libcrypto.so.0 libssl.so.0
  to keep upper compat.

* Thu Apr 26 2001 Toshihiro Yamagishi<toshihiro@turbolinux.co.jp>
- updated to 0.9.6a

* Wed Sep 27 2000 Toshihiro Yamagishi<toshihiro@turbolinux.co.jp>
- up to 0.9.6

* Tue Aug 15 2000 Toshihiro Yamagishi<toshihiro@turbolinux.co.jp>
- up to 0.9.5a
- modified mandir to %{_mandir}

* Fri Jun 30 2000 Go Taniguchi <go@turbolinux.co.jp>
- fixed spec file for centro
- added man files

* Fri Mar 03 2000 Toshihiro Yamagishi <toshihiro@turbolinux.co.jp>
- delete IDEA supportp
- up to 0.9.5
- modified spec name to openssl.spec
* Tue Feb 08 2000 Takeshi Aihana <aihana@turbolinux.co.jp>
- Rebuild for TurboLinux Workstation 6.0J
* Sun Dec  5 1999 Akira Higuchi <a@kondara.org>
- Added Distribution and NoSource tags
- Added settings for alpha to the Configure script
* Thu Oct 14 1999 Damien Miller <djm@mindrot.org>
- Set default permissions
- Removed documentation from devel sub-package
* Thu Sep 30 1999 Damien Miller <djm@mindrot.org>
- Added "make test" stage
- GPG signed
* Tue Sep 10 1999 Damien Miller <damien@ibs.com.au>
- Updated to version 0.9.4
* Tue May 25 1999 Damien Miller <damien@ibs.com.au>
- Updated to version 0.9.3
- Added attributes for all files
- Paramatised openssl directory
* Sat Mar 20 1999 Carlo M. Arenas Belon <carenas@jmconsultores.com.pe>
- Added "official" bnrec patch and taking other out
- making a link from ssleay to openssl binary
- putting all changelog together on SPEC file
* Fri Mar  5 1999 Henri Gomez <gomez@slib.fr>
- Added bnrec patch
* Tue Dec 29 1998 Jonathan Ruano <kobalt@james.encomix.es>
- minimum spec and patches changes for openssl
- modified for openssl sources
* Sat Aug  8 1998 Khimenko Victor <khim@sch57.msk.ru>
- shared library creating process honours $RPM_OPT_FLAGS
- shared libarry supports threads (as well as static library)
* Wed Jul 22 1998 Khimenko Victor <khim@sch57.msk.ru>
- building of shared library completely reworked
* Tue Jul 21 1998 Khimenko Victor <khim@sch57.msk.ru>
- RPM is BuildRoot'ed
* Tue Feb 10 1998 Khimenko Victor <khim@sch57.msk.ru>
- all stuff is moved out of /usr/local

%prep
rm -rf $RPM_BUILD_ROOT

%setup -q
%patch0 -p1 -b .make
%patch1 -p1 -b .sec
%patch2 -p1 -b .asn
%patch3 -p1 -b .malloc-negative
%patch4 -p1 -b .vaudenay
%patch5 -p0 -b .sec3-blinding
pushd ssl
%patch6 -p0 -b .klima-pokorny-rosa
popd

# Set path to perl 
perl util/perlpath.pl /usr/bin/perl

%build
%ifarch alpha
./Configure -DNO_IDEA no-idea --prefix=%{prefix} --openssldir=%{openssldir} linux-alpha-elf shared
%endif
%ifarch ia64
./Configure -DNO_IDEA no-idea --prefix=%{prefix} --openssldir=%{openssldir} linux-ia64 shared
%endif
%ifarch ppc
./Configure -DNO_IDEA no-idea --prefix=%{prefix} --openssldir=%{openssldir} linux-ppc shared
%endif
%ifarch i386 i486 i586 i686
./Configure -DNO_IDEA no-idea --prefix=%{prefix} --openssldir=%{openssldir} linux-elf shared
%endif

LD_LIBRARY_PATH=`pwd` make 
LD_LIBRARY_PATH=`pwd` make rehash
LD_LIBRARY_PATH=`pwd` make test

%install
rm -rf $RPM_BUILD_ROOT
make install MANDIR=%{_mandir} INSTALL_PREFIX="$RPM_BUILD_ROOT"

# rename man 
for x in $RPM_BUILD_ROOT%{_mandir}/man*/* 
        do mv ${x} ${x}ssl
done

# Install RSAref stuff
install -m644 rsaref/rsaref.h $RPM_BUILD_ROOT%{prefix}/include/openssl
install -m644 libRSAglue.a $RPM_BUILD_ROOT%{prefix}/lib

# Make backwards-compatibility symlink to ssleay
ln -s %{prefix}/bin/openssl $RPM_BUILD_ROOT%{prefix}/bin/ssleay
# Install shared libs
# cdcp -a lib*.so* $RPM_BUILD_ROOT%{prefix}/lib

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(0644,root,root,0755)
%doc CHANGES CHANGES.SSLeay LICENSE NEWS README doc
%attr(0755,root,root) %{prefix}/bin/*
%attr(0755,root,root) %{prefix}/lib/*.so.*
%attr(0755,root,root) %{openssldir}/misc/*
%config %attr(0644,root,root) %{openssldir}/openssl.cnf 
%dir %attr(0755,root,root) %{openssldir}/certs
%dir %attr(0755,root,root) %{openssldir}/lib
%dir %attr(0755,root,root) %{openssldir}/misc
%dir %attr(0750,root,root) %{openssldir}/private
%attr(0644,root,root) %{_mandir}/man1/*
#%attr(0644,root,root) %{prefix}/man/man5/*

%files devel
%defattr(0644,root,root,0755)
%attr(0644,root,root) %{prefix}/lib/*.so
%attr(0644,root,root) %{prefix}/lib/*.a
%attr(0644,root,root) %{prefix}/include/openssl/*
%attr(0644,root,root) %{_mandir}/man3/*
%attr(0644,root,root) %{_mandir}/man7/*

%post
/sbin/ldconfig

%postun
if [ "$1" = "0" ]; then
  /sbin/ldconfig
fi
